<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: ButtonsCommanderEncoder Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classButtonsCommanderEncoder.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classButtonsCommanderEncoder-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ButtonsCommanderEncoder Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="ButtonsCommanderEncoder_8hpp_source.html">ButtonsCommanderEncoder.hpp</a>&quot;</code></p>
<div class="dynheader">
Inheritance diagram for ButtonsCommanderEncoder:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classButtonsCommanderEncoder.png" usemap="#ButtonsCommanderEncoder_map" alt=""/>
  <map id="ButtonsCommanderEncoder_map" name="ButtonsCommanderEncoder_map">
<area href="classButtonsCommanderButton.html" alt="ButtonsCommanderButton" shape="rect" coords="0,0,168,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2d32ba9af1f29577aa9137f414caa3d3"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderEncoder.html#a2d32ba9af1f29577aa9137f414caa3d3">ButtonsCommanderEncoder</a> ()</td></tr>
<tr class="separator:a2d32ba9af1f29577aa9137f414caa3d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9cc403a8374e4d9493648b3cfb8c869"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderEncoder.html#af9cc403a8374e4d9493648b3cfb8c869">GetPosition</a> () const </td></tr>
<tr class="separator:af9cc403a8374e4d9493648b3cfb8c869"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6c9f3c48d4587b2fde0b270ed2d9b85"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderEncoder.html#ad6c9f3c48d4587b2fde0b270ed2d9b85">ResetStartingPosition</a> ()</td></tr>
<tr class="separator:ad6c9f3c48d4587b2fde0b270ed2d9b85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae16003a4ee9c3b80c78194a8de43b8ac"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderEncoder.html#ae16003a4ee9c3b80c78194a8de43b8ac">begin</a> (unsigned long inId, int inPin1, int inPin2, byte inMoveIncrement = 3, int inStartingCurrentValue = 0, int inMinimum = 0, int inMaximum = 0)</td></tr>
<tr class="separator:ae16003a4ee9c3b80c78194a8de43b8ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fa7dfee89534eaa194aa578d53427a9"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderEncoder.html#a7fa7dfee89534eaa194aa578d53427a9">loop</a> ()</td></tr>
<tr class="separator:a7fa7dfee89534eaa194aa578d53427a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classButtonsCommanderButton"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classButtonsCommanderButton')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></td></tr>
<tr class="memitem:afd8cb1a2b76510830062c5656bda0728 inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#afd8cb1a2b76510830062c5656bda0728">ButtonsCommanderButton</a> (unsigned long inId)</td></tr>
<tr class="separator:afd8cb1a2b76510830062c5656bda0728 inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbdd1d63fed7736c7358105428fbfd9c inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">GetId</a> () const </td></tr>
<tr class="separator:acbdd1d63fed7736c7358105428fbfd9c inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ab1295abfbfafef48d38a8795fb0be7 inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">virtual ButtonsCommanderButton *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a1ab1295abfbfafef48d38a8795fb0be7">GetFromId</a> (unsigned long inId)</td></tr>
<tr class="separator:a1ab1295abfbfafef48d38a8795fb0be7 inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1f260c75fbe475f674107bdc96f26cd inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#ae1f260c75fbe475f674107bdc96f26cd">beforeFirstLoop</a> ()</td></tr>
<tr class="separator:ae1f260c75fbe475f674107bdc96f26cd inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a270eade0db966b7e72b6dc5462377593 inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a270eade0db966b7e72b6dc5462377593">EndLoop</a> ()</td></tr>
<tr class="separator:a270eade0db966b7e72b6dc5462377593 inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fa0ef8aede172936672b384f81b03bb inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a7fa0ef8aede172936672b384f81b03bb">SetNextButton</a> (ButtonsCommanderButton *inpButton)</td></tr>
<tr class="separator:a7fa0ef8aede172936672b384f81b03bb inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dac1c9fcdc5bbe1d2b00a38192f555c inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">ButtonsCommanderButton *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a0dac1c9fcdc5bbe1d2b00a38192f555c">GetNextButton</a> () const </td></tr>
<tr class="separator:a0dac1c9fcdc5bbe1d2b00a38192f555c inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_classButtonsCommanderButton"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classButtonsCommanderButton')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></td></tr>
<tr class="memitem:a3b40667770ab04694a2ea85f11aebfe0 inherit pro_attribs_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a></td></tr>
<tr class="separator:a3b40667770ab04694a2ea85f11aebfe0 inherit pro_attribs_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class describes a rotary encoder. A rotary or "shaft" encoder is an angular measuring device. It is used to precisely measure rotation of motors or to create wheel controllers (knobs) that can turn infinitely (with no end stop like a potentiometer has). Some of them are also equipped with a pushbutton when you press on the axis (like the ones used for navigation on many music controllers). In this case, only add a new <a class="el" href="classButtonsCommanderPush.html">ButtonsCommanderPush</a> class instance beside the encoder. This class can handles also a current position, using the encoder like a potentiometer...</p>
<p>Events thrown:</p>
<table class="doxtable">
<tr>
<th>reason </th><th>id </th><th>type </th><th>data  </th></tr>
<tr>
<td>clockwise movement </td><td>button id </td><td><a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a> </td><td><a class="el" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baae1923028184f9ee153eb5370ab58ca65">COMMANDERS_MOVE_MORE</a> </td></tr>
<tr>
<td>counter-clockwise movement </td><td>button id </td><td><a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a> </td><td><a class="el" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baad77b8c7aff05833a7b178bf1318ce15d">COMMANDERS_MOVE_LESS</a> </td></tr>
<tr>
<td>positional position changed </td><td>button id </td><td><a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca820fe8d0aad337114732954c5965e82b">COMMANDERS_EVENT_MOVEPOSITION</a> </td><td>value </td></tr>
</table>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderEncoder_8hpp_source.html#l00028">28</a> of file <a class="el" href="ButtonsCommanderEncoder_8hpp_source.html">ButtonsCommanderEncoder.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a2d32ba9af1f29577aa9137f414caa3d3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ButtonsCommanderEncoder::ButtonsCommanderEncoder </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderEncoder_8cpp_source.html#l00011">11</a> of file <a class="el" href="ButtonsCommanderEncoder_8cpp_source.html">ButtonsCommanderEncoder.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ae16003a4ee9c3b80c78194a8de43b8ac"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ButtonsCommanderEncoder::begin </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inPin1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inPin2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">byte&#160;</td>
          <td class="paramname"><em>inMoveIncrement</em> = <code>3</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inStartingCurrentValue</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inMinimum</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inMaximum</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initialize the instance. This encoder can be use like a potentiometer. To use this positional value, give a different value to minimum and maximum arguments. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>id of the button. </td></tr>
    <tr><td class="paramname">inPin1</td><td>Arduino pin connected to this encoder. </td></tr>
    <tr><td class="paramname">inPin2</td><td>Arduino pin connected to this encoder. </td></tr>
    <tr><td class="paramname">inMoveIncrement</td><td>minimum change value to throw a new event. Default is 3, but it can depends of the material used. </td></tr>
    <tr><td class="paramname">inStartingCurrentValue</td><td>In positional use, starting position. Must be between minimum and maximum ! Default is 0. </td></tr>
    <tr><td class="paramname">inMinimum</td><td>minimum value in positional use, default is 0. </td></tr>
    <tr><td class="paramname">inMaximum</td><td>maximum value in positional use, default is 0. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderEncoder_8cpp_source.html#l00015">15</a> of file <a class="el" href="ButtonsCommanderEncoder_8cpp_source.html">ButtonsCommanderEncoder.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="af9cc403a8374e4d9493648b3cfb8c869"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int ButtonsCommanderEncoder::GetPosition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets current value of the positional mode. </p>

<p>Reimplemented from <a class="el" href="classButtonsCommanderButton.html#a823f11a7de3a5a01d0c076f7d5b4fae0">ButtonsCommanderButton</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderEncoder_8hpp_source.html#l00045">45</a> of file <a class="el" href="ButtonsCommanderEncoder_8hpp_source.html">ButtonsCommanderEncoder.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a7fa7dfee89534eaa194aa578d53427a9"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long ButtonsCommanderEncoder::loop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Main loop function. </p>

<p>Reimplemented from <a class="el" href="classButtonsCommanderButton.html#a44bbb289ce1f64b42a88126e8dd42f7e">ButtonsCommanderButton</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderEncoder_8cpp_source.html#l00035">35</a> of file <a class="el" href="ButtonsCommanderEncoder_8cpp_source.html">ButtonsCommanderEncoder.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ad6c9f3c48d4587b2fde0b270ed2d9b85"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ButtonsCommanderEncoder::ResetStartingPosition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Resets the current value of the positional mode to its starting value. </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderEncoder_8hpp_source.html#l00047">47</a> of file <a class="el" href="ButtonsCommanderEncoder_8hpp_source.html">ButtonsCommanderEncoder.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="ButtonsCommanderEncoder_8hpp_source.html">ButtonsCommanderEncoder.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="ButtonsCommanderEncoder_8cpp_source.html">ButtonsCommanderEncoder.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classButtonsCommanderEncoder.html">ButtonsCommanderEncoder</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
